<template>
    <div class="cockpit">
        <div ref="collapsible" class="group" :style="{ height: (collapsed ? 0 : collapsible.scrollHeight + 'px') }" :class="{ 'inherit-overflow': cameraSelectExpanded || microphoneSelectExpanded }">
            <div class="row">
                <div class="label">Camera: </div>
                <Select class="value select" :model-value="camera.device" :options="camera.devices" :optionLabel="(c) => c.getLabel()" append-to="self" @change="(event) => onCameraSelected(event.value)" @before-show="cameraSelectExpanded = true" @before-hide="cameraSelectExpanded = false"/>
            </div>
            <div class="row">
                <div class="label">Microphone: </div>
                <Select class="value select" :model-value="microphone.device" :options="microphone.devices" :optionLabel="(m) => m.getLabel()" append-to="self" @change="(event) => onMicrophoneSelected(event.value)" @before-show="microphoneSelectExpanded = true" @before-hide="microphoneSelectExpanded = false"/>
            </div>
            <div class="row flex-end">
                <div class="label">Noise cancellation: </div>
                <ToggleSwitch class="value" ref="denoiseficationButton" :disabled="microphone.devices.length === 0" :model-value="microphone.denoiseficationOn" @change="onDenoiseficationButtonClicked" />
            </div>
            <div class="row flex-end">
                <div class="label">Statistics: </div>
                <ToggleSwitch class="value" :model-value="statisticsOn" @change="$emit('onCockpitStatisticsButtonClicked')"/>
            </div>
            <div class="row flex-end">
                <div class="label">Single stream mode (MCU): </div>
                <ToggleSwitch class="value" :model-value="singleStreamMode" @change="$emit('onCockpitSingleStreamModeButtonClicked')"/>
            </div>
            <div class="row flex-end">
                <div class="label">Self view: </div>
                <ToggleSwitch class="value" v-model="selfView"/>
            </div>
            <div class="row flex-end">
                <div class="label">QR coded room URI: </div>
                <a class="link" :href="'https://quickchart.io/qr?light=0e0e0e&dark=ffffff&ecLevel=L&size=400&text=' + encodeURIComponent(roomURI)" target="_blank"/>
            </div>
            <div class="row flex-end">
                <div class="label">Recording: </div>
                <a class="link" :href="recordingUrl" target="_blank"/>
            </div>
            <div class="spacer"></div>
        </div>
        <div class="group">
            <div class="row centered">
                <button class="button camera" :class="{ on: camera.on }" ref="cameraButton" @click="onCameraButtonClicked" v-show="camera.devices.length > 0"/>
                <button class="button microphone" :class="{ on: microphone.on }" ref="microphoneButton" @click="onMicrophoneButtonClicked" v-show="microphone.devices.length > 0"/>
                <button class="button screen" :class="{ on: screen.on }" ref="screenButton" @click="onScreenButtonClicked" v-show="!!screen.device"/>
                <button class="button recording" :class="{ on: recordingOn }" @click="$emit('onCockpitRecordingButtonClicked')"/>
                <button class="button chat" :class="{ on: chatOn }" @click="$emit('onCockpitChatButtonClicked')"/>
                <button class="button expand-collapse" :class="{ collapsed: collapsed }" @click="collapsed = !collapsed"/>
            </div>
        </div>
    </div>
</template>

<script setup>

    import { onMounted, onUnmounted, reactive, ref, shallowRef } from "vue";
    import { MindSDK, DeviceRegistryListener, CameraListener, MicrophoneListener, ScreenListener } from "mind-sdk-web";
    import Select from "primevue/select";
    import ToggleSwitch from "primevue/toggleswitch";

    const camera = reactive({
        devices: shallowRef([]),
        device: shallowRef(null),
        on: true,
    });

    const microphone = reactive({
        devices: shallowRef([]),
        device: shallowRef(null),
        on: true,
        denoiseficationOn: false,
    });

    const screen = reactive({
        device: shallowRef(null),
        on: false,
    });

    let primaryMediaStream = null;
    let secondaryMediaStream = null;

    const onCameraSelected = (device) => {
        if (camera.device !== device) {
            if (camera.on) {
                onCameraButtonClicked();
                camera.device = device;
                onCameraButtonClicked();
            } else {
                camera.device = device;
            }
            emitPrimaryMediaStream();
        }
    };

    const onMicrophoneSelected = (device) => {
        if (microphone.device !== device) {
            if (microphone.on) {
                onMicrophoneButtonClicked();
                microphone.device = device;
                onMicrophoneButtonClicked();
            } else {
                microphone.device = device;
            }
            emitPrimaryMediaStream();
        }
    };

    const onCameraButtonClicked = () => {
        if (camera.device) {
            if (!camera.on) {
                cameraButton.value.disabled = true;
                let isMobileBrowsers = navigator.maxTouchPoints > 1;
                if (isMobileBrowsers) {
                    camera.device.setResolution(640, 360);
                    camera.device.setBitrate(600_000)
                    camera.device.setAdaptivity(2);
                } else {
                    camera.device.setResolution(1280, 720);
                    camera.device.setBitrate(2520_000)
                    camera.device.setAdaptivity(3);
                }
                camera.device.setFps(30);
                camera.device.setListener(new class extends CameraListener {
                   onCameraReleasedForcibly() {
                       camera.device.setListener(null);
                       camera.device = null;
                       onCameraSelected(camera.devices[0] || null);
                   }
                });
                camera.device.acquire().then(() => {
                    camera.on = true;
                    cameraButton.value.disabled = false;
                }).catch((error) => {
                    alert("Can't acquire the camera: " + error.message);
                    cameraButton.value.disabled = false;
                });
            } else {
                camera.device.setListener(null);
                camera.device.release();
                camera.on = false;
            }
        } else {
            camera.on = false;
        }
    };

    const onMicrophoneButtonClicked = () => {
        if (microphone.device) {
            if (!microphone.on) {
                microphoneButton.value.disabled = true;
                denoiseficationButtonDisabled.value = true;
                microphone.device.setNoiseSuppression(microphone.denoiseficationOn);
                microphone.device.setListener(new class extends MicrophoneListener {
                    onMicrophoneReleasedForcibly() {
                        microphone.device.setListener(null);
                        microphone.device = null;
                        onMicrophoneSelected(microphone.devices[0] || null);
                    }
                });
                microphone.device.acquire().then(() => {
                    microphone.on = true;
                    microphoneButton.value.disabled = false;
                    denoiseficationButtonDisabled.value = false;
                }).catch((error) => {
                    alert("Can't acquire the microphone: " + error.message);
                    microphoneButton.value.disabled = false;
                    denoiseficationButtonDisabled.value = false;
                });
            } else {
                microphone.device.setListener(null);
                microphone.device.release();
                microphone.on = false;
            }
        } else {
            microphone.on = false;
        }
    };

    const onDenoiseficationButtonClicked = () => {
        microphone.denoiseficationOn = !microphone.denoiseficationOn;
        if (microphone.on) {
            onMicrophoneButtonClicked();
            onMicrophoneButtonClicked();
        }
    };

    const onScreenButtonClicked = () => {
        if (screen.device) {
            if (!screen.on) {
                screenButton.value.disabled = true;
                screen.device.setAudioCapturing(true);
                screen.device.setFps(30);
                screen.device.setListener(new class extends ScreenListener {
                    onScreenReleasedForcibly() {
                        screen.device.setListener(null);
                        screen.on = false;
                        emitSecondaryMediaStream();
                    }
                });
                screen.device.acquire().then(() => {
                    screen.on = true;
                    screenButton.value.disabled = false;
                    emitSecondaryMediaStream();
                }).catch((error) => {
                    alert("Can't acquire the screen: " + error.message);
                    screenButton.value.disabled = false;
                });
            } else {
                screen.device.setListener(null);
                screen.device.release();
                screen.on = false;
                emitSecondaryMediaStream();
            }
        } else {
            screen.on = false;
            emitSecondaryMediaStream();
        }
    };

    const emit = defineEmits([ "onCockpitPrimaryMediaStream",
                               "onCockpitSecondaryMediaStream",
                               "onCockpitStatisticsButtonClicked",
                               "onCockpitSingleStreamModeButtonClicked",
                               "onCockpitRecordingButtonClicked",
                               "onCockpitChatButtonClicked" ]);

    const emitPrimaryMediaStream = () => {
        primaryMediaStream = microphone.device != null || camera.device != null ? MindSDK.createMediaStream(microphone.device, camera.device) : null;
        updateMaxVideoFrameAreaOfPrimaryMediaStream();
        emit("onCockpitPrimaryMediaStream", primaryMediaStream);
    }

    const emitSecondaryMediaStream = () => {
        secondaryMediaStream = screen.on ? MindSDK.createMediaStream(screen.device, screen.device) : null;
        updateMaxVideoFrameAreaOfPrimaryMediaStream();
        emit("onCockpitSecondaryMediaStream", secondaryMediaStream);
    }

    const updateMaxVideoFrameAreaOfPrimaryMediaStream = () => {
        if (primaryMediaStream != null) {
            primaryMediaStream.setMaxVideoFrameArea(secondaryMediaStream == null ? Number.POSITIVE_INFINITY : 320 * 180);
        }
    }

    onMounted(() => {
        let deviceRegistry = MindSDK.getDeviceRegistry();
        camera.devices = deviceRegistry.getCameras();
        microphone.devices = deviceRegistry.getMicrophones();
        screen.device = deviceRegistry.getScreen();
        emitPrimaryMediaStream();
        deviceRegistry.setListener(new class extends DeviceRegistryListener {
            onDeviceRegistryChanged() {
                camera.devices = deviceRegistry.getCameras().slice();
                microphone.devices = deviceRegistry.getMicrophones().slice();
            }
        });
    });

    onUnmounted(() => {
        let deviceRegistry = MindSDK.getDeviceRegistry();
        deviceRegistry.setListener(null);
        if (microphone.device) {
            microphone.device.setListener(null);
            microphone.device.release();
        }
        if (camera.device) {
            camera.device.setListener(null);
            camera.device.release();
        }
        if (screen.device) {
            screen.device.setListener(null);
            screen.device.release();
        }
    });

    defineProps({
        recordingOn: {
            type: Boolean,
            default: false
        },
        recordingUrl: String,
        singleStreamMode: {
            type: Boolean,
            default: false
        },
        statisticsOn: {
            type: Boolean,
            default: false
        },
        chatOn: {
            type: Boolean,
            default: false
        }
    });

    const roomURI = location.href;

    const cameraButton = ref(null);
    const microphoneButton = ref(null);
    const denoiseficationButton = ref(null);
    const screenButton = ref(null);

    const cameraSelectExpanded = ref(false);
    const microphoneSelectExpanded = ref(false);

    const denoiseficationButtonDisabled = ref(false);

    const collapsed = ref(true);
    const collapsible = ref(null);
    const selfView = ref(true);

    const initialize = () => {
        onCameraSelected(camera.devices[0] || null);
        onMicrophoneSelected(microphone.devices[0] || null);
    };

    defineExpose({
        initialize,
        collapsed,
        selfView
    });

</script>

<style scoped>

    .cockpit {
        background: #212121;
        padding: 20px;
        display: flex;
    }

    .group {
        transition: height 300ms;
        overflow: hidden;
    }

    .group.inherit-overflow {
        overflow: inherit !important;
    }

    .row {
        display: flex;
        align-items: center;
    }

    .row:not(:first-child) {
        margin-top: 15px;
    }

    .spacer {
        height: 30px;
    }

    .flex-end {
        justify-content: flex-end;
    }

    .centered {
        justify-content: center;
    }

    .label {
        flex: 1;
    }

    .value {
    }

    .select {
        width: 200px;
    }

    .button {
        display: flex;
        width: 42px;
        height: 42px;
        border: none;
        padding: 0;
        line-height: normal;
        text-decoration: none;
        -webkit-mask-size: cover;
        mask-size: cover;
    }

    .button:not(:first-child) {
        margin-left: 10px;
    }

    .button.camera {
        background-color: #ffffff;
        -webkit-mask-image: url("../assets/camera_off.svg");
        mask-image: url("../assets/camera_off.svg");
    }

    .button.camera.on {
        background-color: #4caf50;
        -webkit-mask-image: url("../assets/camera_on.svg");
        mask-image: url("../assets/camera_on.svg");
    }

    .button.microphone {
        background-color: #ffffff;
        -webkit-mask-image: url("../assets/microphone_off.svg");
        mask-image: url("../assets/microphone_off.svg");
    }

    .button.microphone.on {
        background-color: #4caf50;
        -webkit-mask-image: url("../assets/microphone_on.svg");
        mask-image: url("../assets/microphone_on.svg");
    }

    .button.screen {
        background-color: #ffffff;
        -webkit-mask-image: url("../assets/screen_sharing.svg");
        mask-image: url("../assets/screen_sharing.svg");
    }

    .button.screen.on {
        background-color: #4caf50;
    }

    .button.recording {
        background-color: #ffffff;
        -webkit-mask-image: url("../assets/recording.svg");
        mask-image: url("../assets/recording.svg");
    }

    .button.recording.on {
        background-color: #f44336;
    }

    .link {
        width: 24px;
        height: 24px;
        background-color: #ffffff;
        -webkit-mask-image: url("../assets/recording_link.svg");
        mask-image: url("../assets/recording_link.svg");
    }

    .button.chat {
        background-color: #ffffff;
        -webkit-mask-image: url("../assets/chat.svg");
        mask-image: url("../assets/chat.svg");
    }

    .button.chat.on {
        background-color: #4caf50;
        -webkit-mask-image: url("../assets/chat.svg");
        mask-image: url("../assets/chat.svg");
    }

    .button.expand-collapse {
        background-color: #ffffff;
        -webkit-mask-image: url("../assets/expand_collapse.svg");
        mask-image: url("../assets/expand_collapse.svg");
        transition: transform 300ms;
        transform: rotate(180deg);
    }

    .button.expand-collapse.collapsed {
        transform: rotate(0deg);
    }

</style>